/*
	Copyright (C) 2011 Micha Hersch, University of Lausanne, Swiss Institute of Bioinformatics

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 * \file nestHistory.h
 * \author Micha Hersch
 * \date 12-20-2010
 */

#ifndef __NEST_HISTORY_H__
#define __NEST_HISTORY_H__

#include <vector>
#include "snake.h"

typedef std::vector<Vec2> SimpleSnake;
typedef std::vector<SimpleSnake> SnakeHistory;
typedef std::vector<SnakeHistory> HistoryBuffer;

class NestHistory{
 protected:
 
  HistoryBuffer buffer;
  uint present;

 public:
  NestHistory();
  void setSnake(const Snake *s, uint i, uint time);
  void getSnake(uint i, uint time, Snake& s);
  int getSnakeSize(uint i,uint tim)const;
  uint getPresent()const{return present;}
  void printAllLengths(std::ostream& out);
  void printAllOrientations(std::ostream& out,float len);
  void printAllSegments(std::ostream& out);
  void printAllTips(std::ostream& out);


};



#endif
